<script setup lang="ts">
    import { dateTimeToDateInputValue } from '@/shared/helpers/dates'
    import { isNullOrUndefined, isUndefined } from '@/shared/helpers/types'
    import { computed } from 'vue'

    const date = defineModel<Date | undefined>()

    const dateInput = computed({
        get() {
            if (isUndefined(date.value)) {
                return undefined
            }
            return dateTimeToDateInputValue(date.value)
        },
        set(stringDate) {
            if (isNullOrUndefined(stringDate) || stringDate === '') {
                date.value = undefined
                return
            }
            date.value = new Date(stringDate)
        },
    })
</script>

<template>
    <v-text-field v-model="dateInput" type="datetime-local"></v-text-field>
</template>
